# Databricks SQL

### Overview

This guide outlines the configuration steps for adding Databricks SQL as a datasource in StrongDM.

When the resource is added, StrongDM proxies client connections through a StrongDM node (gateway, relay, or proxy cluster). This enables centralized access control, credential management, and audit logging.

To connect to Databricks SQL, you’ll need your Databricks workspace Server Hostname and the SQL warehouse or cluster HTTP Path, which are available in the Databricks connection details.

For general information about how to add a database as a resource in StrongDM, see our main guide, [Add a Datasource](https://docs.strongdm.com/admin/resources/datasources).

## Supported Versions and Clients

Databricks SQL is typically accessed via standard JDBC and ODBC clients and drivers (for example, BI tools and SQL IDEs) using Databricks workspace hostname and HTTP Path connection settings.

## Prerequisites

To add your resource in StrongDM, you need to meet several technical and configuration prerequisites. Please ensure that the following requirements are met.

In StrongDM, you must have the following:

* Administrator permission level
* At least one operational StrongDM node (gateway, relay, or proxy cluster) with network access to your Databricks workspace hostname (typically on port 443)
* If using secrets management tools for storing your Databricks credentials, a Secret Store configured in StrongDM

{% hint style="info" %}
To verify that the resource is accessible by the node, log in to the gateway or relay and use Netcat: `nc -zv <HOSTNAME> <PORT>` (in this example, `nc -zv testdb-01.fancy.org 3306`). If your gateway server can connect to this hostname, proceed.

Netcat is a tool for checking various hostnames and ports by either sending data (a ping) or checking for listeners on the ports. The command in the aforementioned example use "-z" to check for listeners without sending data and "-v" to show verbose output. If you don't have Netcat, you can install the Netcat package with whatever package manager you are using, such as "apt-get install netcat".
{% endhint %}

On the Databricks side, you must have the following:

* Access to a Databricks workspace
* A SQL warehouse or cluster you intend to query
* A Databricks authentication mechanism you will use with StrongDM (commonly a Personal Access Token (PAT))

{% hint style="info" %}
In Databricks, the connection details you need are typically listed as **Server Hostname**, **Port**, and **HTTP Path** for the SQL warehouse.
{% endhint %}

## Resource Management in StrongDM

After all prerequisites and prep work is done, you are ready to add the resource to StrongDM. This section provides instructions for adding the resource in either the StrongDM Admin UI, CLI, Terraform provider, or SDKs.

{% tabs %}
{% tab title="Admin UI" %}
**Set up and Manage With the Admin UI**

If using the Admin UI to add Databricks SQL as a resource to StrongDM, use the following steps.

1. Log in to the StrongDM Admin UI.
2. Go to **Resources** > **Managed Resources**.
3. Click **Add Resource**.
4. For **Resource Type**, select **Databricks SQL**.
5. Complete all required [configuration properties](#configuration-properties) for your selected datasource type.
6. Click **Create** to save the resource.
7. Click the resource name to view status, diagnostic information, and setting details.
   {% endtab %}

{% tab title="CLI" %}
**Set up and Manage With the CLI**

This section provides an example of how to add the resource using the StrongDM CLI. For more information and examples, please see the [CLI Reference](https://app.gitbook.com/s/4XOJmXFslCMVCzIG2rKp/cli) documentation.

```
# Add Databricks SQL datasource
sdm admin datasources add databricks analytics-warehouse
  --hostname="dbc-example.cloud.databricks.com"
  --http-path="/sql/1.0/warehouses/abc123def456"
  --access-token="dapiXXXXXXXXXXXXXXXX"
  --connectivity-mode="vnm"
  --ip-address="100.64.100.100"
  --port-override="15443"
  --dns="databricks-analytics"
  --proxy-cluster-id="n-1a2b345c67890123"
  --secret-store-id="se-e1b2"
  --tags="env=production,team=analytics"
```

{% endtab %}

{% tab title="Terraform" %}
**Set up and Manage With Terraform**

This section provides an example of how to configure and manage the resource using the Terraform provider. For more information and examples, please see the [Terraform provider](https://github.com/strongdm/terraform-provider-sdm) documentation.

```
# Install StrongDM provider
terraform {
  required_providers {
    sdm = {
      source  = "strongdm/sdm"
      version = ">= 16.15.0"
    }
  }
}

# Configure StrongDM provider
provider "sdm" {
  # Add API access key and secret key from Admin UI
  api_access_key = "njjSn...5hM"
  api_secret_key = "ziG...="
}

# Create Databricks SQL resource
resource "sdm_resource" "databricks_sql" {
  databricks_sql {
     name = "analytics-warehouse"
     
     # Required
     hostname = "dbc-example.cloud.databricks.com"
     http_path = "/sql/1.0/warehouses/abc123def456"
     access_token = "dapiXXXXXXXXXXXXXXXX"
     
     # Optional (StrongDM networking/routing)
     proxy_cluster_id = "n-1a2b345c67890123"
     secret_store_id = "se-e1b2"
     
     # If you’re using Virtual Networking Mode
     # Field names may vary slightly by provider version
     connectivity_mode = "vnm"
     ip_address = "100.64.100.100"
     port_override = 15443
     dns = "databricks-analytics"
     
     tags = {
       env = "production"
       team = "analytics"
    }
  }
}
```

{% endtab %}

{% tab title="SDKs" %}
**Set up and manage with SDKs**

In addition to the Admin UI, CLI, and Terraform, you may configure and manage your resource with any of the following SDK options: Go, Java, Python, and Ruby. Please see the following references for more information and examples.

| Language      | Reference                                                                | GitHub                                                                 | Examples                                                                        |
| ------------- | ------------------------------------------------------------------------ | ---------------------------------------------------------------------- | ------------------------------------------------------------------------------- |
| Go            | [pkg.go.dev](https://pkg.go.dev/github.com/strongdm/strongdm-sdk-go/v16) | [strongdm-sdk-go](https://github.com/strongdm/strongdm-sdk-go)         | [Go SDK Examples](https://github.com/strongdm/strongdm-sdk-go-examples)         |
| Java          | [javadoc](https://strongdm.github.io/strongdm-sdk-java-docs/)            | [strongdm-sdk-java](https://github.com/strongdm/strongdm-sdk-java)     | [Java SDK Examples](https://github.com/strongdm/strongdm-sdk-java-examples)     |
| Python        | [pdocs](https://strongdm.github.io/strongdm-sdk-python-docs/)            | [strongdm-sdk-python](https://github.com/strongdm/strongdm-sdk-python) | [Python SDK Examples](https://github.com/strongdm/strongdm-sdk-python-examples) |
| Ruby          | [RubyDoc](https://www.rubydoc.info/gems/strongdm)                        | [strongdm-sdk-ruby](https://github.com/strongdm/strongdm-sdk-ruby)     | [Ruby SDK Examples](https://github.com/strongdm/strongdm-sdk-ruby-examples)     |
| {% endtab %}  |                                                                          |                                                                        |                                                                                 |
| {% endtabs %} |                                                                          |                                                                        |                                                                                 |

## **Configuration Properties**

The following table describes the settings available for Databricks SQL.

| Property              | Requirement | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| --------------------- | ----------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| **Display Name**      | Required    | Meaningful name to display the resource throughout StrongDM; exclude special characters like quotes (") or angle brackets (< or >)                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| **Resource Type**     | Required    | **Databricks SQL**                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| **Proxy Cluster**     | Required    | Defaults to "None (use gateways)"; if using [proxy clusters](https://docs.strongdm.com/admin/networking/proxy-clusters), select the appropriate cluster to proxy traffic to this resource                                                                                                                                                                                                                                                                                                                                                                                                  |
| **Hostname**          | Required    | Hostname for your resource (for example, `dbc-example.cloud.databricks.com`); [must be accessible](#prerequisites) to a gateway or relay                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| **Connectivity Mode** | Required    | Select either **Virtual Networking Mode**, which lets users connect to the resource with a software-defined, IP-based network; or **Loopback Mode**, which allows users to connect to the resource using the local loopback adapter in their operating system                                                                                                                                                                                                                                                                                                                              |
| **IP Address**        | Optional    | If **Virtual Networking Mode** is the selected connectivity mode, an IP address value in the range `100.64.0.1` to `100.127.255.252` (default `100.64.100.100`); optionally change the default value for Virtual Networking Mode to your preferred IP address value, as long as it's a valid IP address defined by your organization settings; edit either on this form or later on the Admin UI's Port Overrides page after the resource is created; if **Loopback Mode** is the selected connectivity mode, the IP address value must be within the range of `127.0.0.1` to `127.0.0.34` |
| **Port Override**     | Optional    | If **Virtual Networking Mode** is the selected connectivity mode, a port value between 1 and 65535 that is not already in use by another resource; if **Loopback Mode** is the selected connectivity mode, a port value between 1024 to 64999 that is not already in use by another resource; when left empty, the system assigns the default port to this resource; preferred port also can be modified later from the [Port Overrides settings](https://docs.strongdm.com/admin/resources/port-overrides)                                                                                |
| **DNS**               | Optional    | If Virtual Networking Mode is the selected connectivity mode, a unique hostname alias for this resource; when set, causes the desktop app to display this resource's human-readable DNS name (for example, `k8s.my-organization-name`) instead of the bind address that includes IP address and port (for example, `100.64.100.100:5432`)                                                                                                                                                                                                                                                  |
| **HTTP Path**         | Required    | HTTP path to your SQL warehouse or cluster; found in the JDBC/ODBC connection details                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| **Secret Store**      | Optional    | Credential store location; defaults to **Stored in StrongDM**; learn more about [Secret Store options](#secret-store-options)                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| **Access Token**      | Required    | Databricks Personal Access Token (PAT) for authentication                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| **Resource Tags**     | Optional    | Datasource [Tags](https://app.gitbook.com/s/4XOJmXFslCMVCzIG2rKp/cli/tags "mention") consisting of key-value pairs `<KEY>=<VALUE>` (for example, `env=dev`)                                                                                                                                                                                                                                                                                                                                                                                                                                |

### Secret Store options

By default, datasource credentials are stored in StrongDM. However, these credentials can also be saved in a secrets management tool.

Non-StrongDM options appear in the **Secret Store** dropdown if they are created under **Settings** > **Secrets Management.** When you select another Secret Store type, its unique properties display. For more details, see [Configure Secret Store Integrations](https://docs.strongdm.com/admin/access/secret-stores).

### Resource status

After a resource is created, the Admin UI displays that resource as unhealthy until the healthchecks run successfully. When the resource is ready, the **Health** icon indicates a positive, green status.

When the resource does not display a positive status, click the resource name to go to the **Diagnostics** tab and check for errors.

## Test the Connection

After you have added your resource in StrongDM, follow these steps to verify that it’s working correctly.

1. Assign yourself access by ensuring that your user or role has access to the resource. In the StrongDM Admin UI, go to **Access** > **Roles**, and verify that the resource is attached to a role you’re in.
2. In the CLI, run `sdm status` to list the available datasources. Confirm that the resource is available.
3. Start a session. For example:

   ```bash
   sdm connect analytics-warehouse
   ```

   See the CLI Reference documentation for details on [sdm connect](https://app.gitbook.com/s/4XOJmXFslCMVCzIG2rKp/cli/connect).
4. Connect using your preferred Databricks-capable SQL client (JDBC/ODBC/BI tool) pointed at the StrongDM-provided local endpoint, and verify you can run a simple query (for example `SELECT 1`).

When these steps succeed, you’re ready to connect to your resource through StrongDM.

### Help

If you encounter issues, please consult the [StrongDM Help Center](https://help.strongdm.com/hc/en-us).

Be prepared to provide the following information to StrongDM Support, so that they can inspect logs and confirm node and resource health:

* Resource name or ID
* CLI error output or logs
* Node name and region


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.strongdm.com/admin/resources/datasources/databricks-sql.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
